-- Cooldown Module

local width, height = 300, 28

--function SN:CoolDowns()

--	--make the frames db local
--	local v = SN.db.profile.Frames
	
--	SN.F.cooldowns = SN.timers:NewGroup(width, "CDGroup", cdowngrp)
--	SN.F.cooldowns:SetSpacing(0, 7)
--	SN.F.cooldowns:SetSorting("SN:arg4")

--	--Check to see if ElvUI is on to integrate SN into it better
--	if(IsAddOnLoaded("ElvUI")) then
--		SN.F.cooldowns:SetSpacing(0, 7)
--		SN.F.cooldowns:SetStartPoint("bottomleft")
--		SN.F.cooldowns:SetPoint(unpack(v.elvcooldowns))
--	else
--		SN.F.cooldowns:SetSpacing(0, 3)
--		SN.F.cooldowns:SetStartPoint("topleft")
--		SN.F.cooldowns:SetPoint(unpack(v.cooldowns))
--	end
	
--	SN.F.cooldowns:SetScript("OnEvent", function(self, event, unit, ...)
--		SN:UpdateCooldown(self, event, unit, ...)
--	end)
--	SN.F.cooldowns:Lock(v.lock)
	
--	--Register our events for the frame
--	SN.F.cooldowns:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
--	SN.F.cooldowns:RegisterCallback("FancyBar_GroupMove", stored)
--end

--function SN:UpdateCooldown(group, event, unit, ...)

--	if event == "COMBAT_LOG_EVENT_UNFILTERED" then

--		local type, _, sourceGUID, sourceName,_,_, destGUID, destName =  ...
--		local spellId, spellName, spellSchool = select(11, ...)

--		--Cycle through our cooldown list
--		for i, cooldown in pairs(SN.db.profile.cooldowns) do
--			if type == cooldown.succ then
--				if spellId == cooldown.id then
--					--Check to see if the cd is a personal only and also if it is enable
--					if (not SN.db.profile.CD.raid) and cooldown.type == "personal" and cooldown.enable then
--						if sourceGUID == UnitGUID("player") then
--							--Check to make up for a cd that requires a cast before it goes on CD.
--							local cast = select(7, GetSpellInfo(spellId))
--							cast = cast * 0.001
--							if cast > 0 then
--								args = { group, cooldown, cooldown.CD, sourceName, sourceGUID, spellName }
--								SN:ScheduleTimer("StartCastDelay", cast, args)
--							else
--								SN:CreateBar(group, cooldown, cooldown.CD, sourceName, sourceGUID, spellName)
--							end
--						end
--					--Check to see if it's a raid CD and is it enabled.
--					elseif (SN.db.profile.CD.raid) and cooldown.type == "raid" and cooldown.enable then
--						if UnitInParty(sourceName) or UnitInRaid(sourceName) or (sourceGUID == UnitGUID("player")) then
--							--Check to make up for a cd that requires a cast before it goes on CD.
--							local cast = select(7, GetSpellInfo(spellId))
--							cast = cast * 0.001
--							if cast > 0 then
--								args = { group, cooldown, cooldown.CD, sourceName, sourceGUID, spellName }
--								SN:ScheduleTimer("StartCastDelay", cast, args)
--							else
--								SN:CreateBar(group, cooldown, cooldown.CD, sourceName, sourceGUID, spellName)
--							end
--						--Send the raid CD to see if it's supposed to be announced.
--						SN:AnnounceCD(cooldown, sourceName)
--						end
--					end
--				end
--			end
--		end
--	end
--end

function SN:StartCastDelay(args)
	SN:CreateBar(args[1], args[2], args[3], args[4], args[5], args[6])
end

function SN:CoolDowns()
	
	local f = SN.F
	local m = SN.Media
	--Make the frames db local
	local v = SN.db.profile.Frames
	
	f.cooldowns = CreateFrame("Frame", CDGroup, UIParent)
	--Check to see if ElvUI is on to integrate SN into it better
	if (IsAddOnLoaded("ElvUI")) then
		f.cooldowns:SetPoint(unpack(v.elvcooldowns))
		f.cooldowns.startpoint = "bottomleft"
		f.cooldowns.spacing_h = 0
		f.cooldowns.spacing_v = 7
	else
		f.cooldowns:SetPoint(unpack(v.cooldowns))
		f.cooldowns.startpoint = "topleft"
		f.cooldowns.spacing_h = 0
		f.cooldowns.spacing_v = 3
	end
	f.cooldowns:SetWidth(300)
	f.cooldowns:SetHeight(24)
	f.cooldowns:SetClampedToScreen(true)

	f.cooldowns:SetScript("OnEvent", function(self, event, unit, ...)
		SN:UpdateCooldown(self, event, unit, ...)
	end)
	--f.cooldowns:Lock(v.lock)
	f.cooldowns.sortfield = "SN:arg4"
	f.cooldowns.bars = {}
	f.cooldowns.maxbars = 0
	f.cooldowns.sortasc = true
	f.cooldowns.frameLocked = 1
	f.cooldowns.name = "cooldowns"
	f.cooldowns.height = 24

	f.cooldowns.value = f.cooldowns:CreateFontString(nil, "ARTWORK")
	f.cooldowns.value:SetFont(m.media.font, 24, "OUTLINE")
	f.cooldowns.value:SetTextColor(0.78, 0.25, 0.25)
	f.cooldowns.value:SetText("")
	f.cooldowns.value:SetAllPoints(f.cooldowns)
	f.cooldowns.value:SetJustifyH("CENTER")
	f.cooldowns.value:SetJustifyV("MIDDLE")

	--Register our events for the frame
	f.cooldowns:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
end

function SN:UpdateCooldown(self, event, unit, ...)

	if event == "COMBAT_LOG_EVENT_UNFILTERED" then

		local type, _, sourceGUID, sourceName, _, _, destGUID, destName =  ...
		local spellId, spellName, spellSchool = select(11, ...)

		--Cycle through our cooldown list
		for i, cooldown in pairs(SN.db.profile.cooldowns) do
			if type == cooldown.succ then
				if spellId == cooldown.id then
					--Check to see if the cd is a personal only and also if it is enable
					if (not SN.db.profile.CD.raid) and cooldown.type == "personal" and cooldown.enable then
						if sourceGUID == UnitGUID("player") then
							--Check to make up for a cd that requires a cast before it goes on CD.
							local cast = select(7, GetSpellInfo(spellId))
							cast = cast * 0.001
							if cast > 0 then
								args = { self, cooldown, cooldown.CD, sourceName, sourceGUID, spellName }
								SN:ScheduleTimer("StartCastDelay", cast, args)
							else
								SN:CreateBar(self, cooldown, cooldown.CD, sourceName, sourceGUID, spellName)
							end
						end
					--Check to see if it's a raid CD and is it enabled.
					elseif (SN.db.profile.CD.raid) and cooldown.type == "raid" and cooldown.enable then
						if UnitInParty(sourceName) or UnitInRaid(sourceName) or (sourceGUID == UnitGUID("player")) then
							--Check to make up for a cd that requires a cast before it goes on CD.
							local cast = select(7, GetSpellInfo(spellId))
							cast = cast * 0.001
							if cast > 0 then
								args = { self, cooldown, cooldown.CD, sourceName, sourceGUID, spellName }
								SN:ScheduleTimer("StartCastDelay", cast, args)
							else
								SN:CreateBar(self, cooldown, cooldown.CD, sourceName, sourceGUID, spellName)
							end
						--Send the raid CD to see if it's supposed to be announced.
						SN:AnnounceCD(cooldown, sourceName)
						end
					end
				end
			end
		end
	end
end