----------------------------------------------
--		Serenity Now						--
--			By Shampow on US-Archimonde		--
----------------------------------------------

SN = LibStub("AceAddon-3.0"):NewAddon("SerenityNow", "AceEvent-3.0", "AceTimer-3.0",  "AceConsole-3.0")
SN.ver = "0.91rc5"

SN.LSM = LibStub("LibSharedMedia-3.0")

--SN.timers = LibStub("LibFancyBar-1.0")
SN.timers = LibStub("LibCandyBar-3.0")

local AceConfig = LibStub("AceConfig-3.0")
local AceConfigDialog = LibStub("AceConfigDialog-3.0")
local AceDB = LibStub("AceDB-3.0")
local AceDBOptions = LibStub("AceDBOptions-3.0")

-- Frames
SN.F = {}
 	
SN.V = LibStub("AceDB-3.0"):New("SNDB", defaults, true)

-- How often the OnUpdate code will run (in seconds)
SN_UpdateInterval = 1.0 

--Are our frames locked?
frameLocked = 1

function SN:OnEnable()
	--Timer Groups
	SN:Debuffs()
	SN:CoolDowns()
	
	--Setup Power Bar
	SN:SetupPower()
	--Setup Threat module
	SN:SetupThreat()
	SN.db.profile.Frames.lock = true
end


function SN:OnInitialize()
	
	--Register the Ace database
	SN.db = AceDB:New("SNDB", SN.V.defaults, true)

	--Setup the clc 
	SN:RegisterChatCommand("sn", "Cmds")

	--Check to see if ElvUI is loaded so we can make the bars purty
	if (IsAddOnLoaded("ElvUI")) then
		local E, L, V, P, G, _ = unpack(ElvUI)
	end

	--Add CD/DB/Threat list to the database
	SN:setupDBList()
	SN:setupCDList()
	SN:setupThreatList()
	SN:SetupOptions()

	--Register this here because bad things happen if it isn't
	SN:RegisterEvent("UNIT_DISPLAYPOWER", "UpdatePowerType")
	
	--start the collecter
	collectgarbage("collect")

	--Lets make the welcome message more visible
	SN:ScheduleTimer("Ver", 10)

end

function SN:Ver()
	print(format("Welcome to |cff0070deSerenity Now|r".." "..SN.ver))
end

function SN:Cmds(input)

	local v1, v2 = input:match("^(%S*)%s*(.-)$")
	v1 = v1:lower()

	if (v1 == "") then	
		print("Serenity Now "..SN.ver)
		print("/sn config - open the config frame.")
		print("/sn lock - unlock/lock the frames.")
		print("/sn reset - reset the frames.")

	elseif (v1 == "options") or (v1 == "config") or (v1 == "opt") or (v1 == "o") then
		AceConfigDialog:Open("SN")
	elseif (v1 == "lock") or (v1 == "unlock") or (v1 == "drag") or (v1 == "move") or (v1 == "l") then
		if SN.db.profile.Frames.lock then
			SN:MoveFrames(false)
			SN.db.profile.Frames.lock = false
		else
			SN:MoveFrames(true)
			SN.db.profile.Frames.lock = true
		end
	elseif (v1 == "reset") or (v1 == "defaults") then
		ResetAnchors()
	else
		print("command not known.")
	end
end

function SN:CheckGlyphs(cooldown)
	checkglyphs = false
	for i = 1, NUM_GLYPH_SLOTS do
		local enabled, glyphType, glyphTooltipIndex, glyphSpellID, icon = GetGlyphSocketInfo(i)
		if ( enabled ) then
			if cooldown['glyphid'] == glyphSpellID then
				checkglyphs = true
			end
		end
	end
	return checkglyphs
end